"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.middleware = void 0;
const validation_error_1 = __importDefault(require("ajv/dist/runtime/validation_error"));
const middleware = (operationId, operations, exclude, operationObject) => {
    const openApiPathMiddleware = (req, res, next) => {
        if (!req.route) {
            return next(new Error(`OpenApiPathMiddleware must be on a route method (get, post, patch, ect) - not on a use`));
        }
        const validate = openApiPathMiddleware.operations.get(operationId);
        if (!validate) {
            return next();
        }
        if (!validate(req)) {
            next(new validation_error_1.default(validate.errors || []));
        }
        return next();
    };
    openApiPathMiddleware.operations = operations;
    openApiPathMiddleware.metadata = { operationId, exclude, operationObject };
    return openApiPathMiddleware;
};
exports.middleware = middleware;
